#include <unistd.h>
#include <openssl/opensslv.h>
#include <openssl/x509.h>
#include <openssl/ssl.h>
#include "fmt.h"
#include "ssl.h"
#include "stralloc.h"
#include "str.h"
#include "tls_remote.h"
#include "case.h"
#include "strerr.h"

int tls_certkey(SSL_CTX *ctx,const char *cert,const char *key,const char *ppwd) 
{
  if (!cert) return 0;

  if (SSL_CTX_use_certificate_chain_file(ctx,cert) != 1)
    return -1;

  if (!key) key = cert;

  if (ppwd) SSL_CTX_set_default_passwd_cb_userdata(ctx,ppwd);

  if (SSL_CTX_use_PrivateKey_file(ctx,key,SSL_FILETYPE_PEM) != 1)
    return -2;

  if (SSL_CTX_check_private_key(ctx) != 1)
    return -3;

  return 0;
}

int tls_conn(SSL *ssl,int smtpfd)
{
  SSL_set_options(ssl,SSL_OP_NO_TLSv1);
  return SSL_set_fd(ssl,smtpfd);
}

int tls_checkpeer(SSL *ssl,const char *host,int flag)
{
  X509 *cert;
  char buf[SSL_NAME_LEN];

  cert = SSL_get_peer_certificate(ssl);
  if (!cert) return -1;

  if (flag == 2 || flag == 3 || flag == 12 || flag == 13)
    if (SSL_get_verify_result(ssl) != X509_V_OK) return -2;

  if (flag == 3 || flag == 13) {
    X509_NAME_get_text_by_NID(X509_get_subject_name(cert),NID_commonName,buf,sizeof buf);
    buf[SSL_NAME_LEN - 1] = 0;
    if (case_diffs(host,buf) != 0) return -3;
  }

  return 0;
}

int tls_checkcrl(SSL *ssl)
{

  return;
}

int tls_exit(SSL *ssl)
{
  if (SSL_shutdown(ssl) == 0)
    SSL_shutdown(ssl);

 return 0;
}
